田草博客

互联网田草博客


网友交流QQ群:11740834 需注明申请加入原因

微信 公众号:ByCAD

邮箱:tiancao1001x126.com
ByCAD,微信公众号
首页 | 普通 | 电脑 | AutoCAD | VB/VB.NET | FLash | 结构 | 建筑 | 电影 | BIM | 规范 | 软件 | ID
-随机-|-分布-
-博客论坛-|-﨣﨤﨧﨨-
-网站导航-|-规范下载-
-BelovedFLash欣赏-

用户登陆
用户:
密码:
 

站点日历
73 2024 - 3 48
     12
3456789
10111213141516
17181920212223
24252627282930
31


站点统计

最新评论



Net 学习 Autodesk_Revit_2016_Chs_Win_64bit_dlm
未知 如何设置过滤器来过滤动态块?   [ 日期:2018-03-21 ]   [ 来自:本站原创 ]  HTML
Creating a selection filter that finds dynamic blocks in AutoCAD using .NET

http://through-the-interface.typepad.com/through_the_interface/2012/09/crea ... inds-dynamic-blocks-in-autocad-using-net.html


Imports Autodesk.AutoCAD.ApplicationServices
Imports Autodesk.AutoCAD.Runtime
Imports Autodesk.AutoCAD.DatabaseServices
Imports Autodesk.AutoCAD.EditorInput
Imports System.Collections.Generic
Namespace EntitySelection
    Public Class Commands
        <CommandMethod("SDB")> _
        Public Shared Sub SelectDynamicBlocks()
            Dim doc As Object = Application.DocumentManager.MdiActiveDocument
            Dim ed As Object = doc.Editor
            Dim pso As Object = New PromptStringOptions(vbLf & "Name of dynamic block to search for")
            pso.AllowSpaces = True
            Dim pr As Object = ed.GetString(pso)
            If pr.Status <> PromptStatus.OK Then
                Return
            End If
            Dim blkName As String = pr.StringResult
            Dim blkNames As New List(Of String)()
            blkNames.Add(blkName)
            Dim tr As Object = doc.TransactionManager.StartTransaction()
            Using tr
                Dim bt As Object = CType(tr.GetObject(doc.Database.BlockTableId, OpenMode.ForRead), BlockTable)
                ' Start by getting access to our block, if it exists
                If Not bt.Has(blkName) Then
                    ed.WriteMessage(vbLf & "Cannot find block called ""{0}"".", blkName)
                    Return
                End If
                ' Get the anonymous block names
                Dim btr As Object = CType(tr.GetObject(bt(blkName), OpenMode.ForRead), BlockTableRecord)
                If Not btr.IsDynamicBlock Then
                    ed.WriteMessage(vbLf & "Cannot find a dynamic block called ""{0}"".", blkName)
                    Return
                End If
                ' Get the anonymous blocks and add them to our list
                Dim anonBlks As Object = btr.GetAnonymousBlockIds()
                For Each bid As ObjectId In anonBlks
                    Dim btr2 As Object = CType(tr.GetObject(bid, OpenMode.ForRead), BlockTableRecord)
                    blkNames.Add(btr2.Name)
                Next
                tr.Commit()
            End Using
            ' Build a conditional filter list so that only
            ' entities with the specified properties are
            ' selected
            Dim sf As New SelectionFilter(CreateFilterListForBlocks(blkNames))
            Dim psr As PromptSelectionResult = ed.SelectAll(sf)
            ed.WriteMessage(vbLf & "Found {0} entit{1}.", psr.Value.Count, (If(psr.Value.Count = 1, "y", "ies")))
        End Sub
        Private Shared Function CreateFilterListForBlocks(ByVal blkNames As List(Of String)) As TypedValue()
            ' If we don't have any block names, return null
            If blkNames.Count = 0 Then
                Return Nothing
            End If
            ' If we only have one, return an array of a single value
            If blkNames.Count = 1 Then
                Return New TypedValue() {New TypedValue(CType(DxfCode.BlockName, Integer), blkNames(0))}
            End If
            ' We have more than one block names to search for...
            ' Create a list big enough for our block names plus
            ' the containing "or" operators
            Dim tvl As New List(Of TypedValue)(blkNames.Count + 2)
            ' Add the initial operator
            tvl.Add(New TypedValue(CType(DxfCode.[Operator], Integer), "<or"))
            ' Add an entry for each block name, prefixing the
            ' anonymous block names with a reverse apostrophe
            For Each blkName As Object In blkNames
                tvl.Add(New TypedValue(CType(DxfCode.BlockName, Integer), (If(blkName.StartsWith("*"), "`" + blkName, blkName))))
            Next
            ' Add the final operator
            tvl.Add(New TypedValue(CType(DxfCode.[Operator], Integer), "or>"))
            ' Return an array from the list
            Return tvl.ToArray()
        End Function
    End Class
End Namespace

注意到过滤的时候在,匿名块名称上加个点  "`"

[本日志由 tiancao1001 于 2018-03-25 07:46 PM 编辑]


暂时没有评论
发表评论 - 不要忘了输入验证码哦!
作者: 用户:  密码:   注册? 验证:  防止恶意留言请输入问题答案:3*4=?  
评论:

禁止表情
禁止UBB
禁止图片
识别链接
识别关键字

字体样式 文字大小 文字颜色
插入粗体文本 插入斜体文本 插入下划线
左对齐 居中对齐 右对齐
插入超级链接 插入邮件地址 插入图像
插入 Flash 插入代码 插入引用
插入列表 插入音频文件 插入视频文件
插入缩进符合
点击下载按钮 下标 上标
水平线 简介分割标记
表  情
 
Tiancao Blog All Rights Reserved 田草博客 版权所有
Copyright ©